//
//  BeatBoxViewController.m
//  BeatBox
//
//  Created by James Gamble on 02/08/2010.
//  Copyright __MyCompanyName__ 2010. All rights reserved.
//

#import "BeatBoxViewController.h"

@implementation BeatBoxViewController

@synthesize img_DotsFull;
@dynamic img_Dots;

@synthesize img_Blank;

CGContextRef ctx;
int BufferHeight;

/*
// The designated initializer. Override to perform setup that is required before the view is loaded.
- (id)initWithNibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil {
    if ((self = [super initWithNibName:nibNameOrNil bundle:nibBundleOrNil])) {
        // Custom initialization
    }
    return self;
}
*/

/*
// Implement loadView to create a view hierarchy programmatically, without using a nib.
- (void)loadView {
}
*/



// Implement viewDidLoad to do additional setup after loading the view, typically from a nib.
- (void)viewDidLoad {
    [super viewDidLoad];
	img_DotsFull=[UIImage imageNamed:@"Dots.png"];
	
	int x=0;  // Start from the left
	int y=0; // Start from the top.
	for (int n=1;n<4;n++) {
		img_Blank=[UIImage imageNamed:@"blankx16.png"]; // Load blank target image
		LockBuffer(img_Blank);  // Lock buffer
		DrawToBuffer(img_DotsFull,x,y);  // Draw onto buffer
		img_Dots[n]=UnlockBuffer(); // Release buffer into variable
		[img_Blank dealloc];  // Free original target
		x=x-16; if (x==-32) {x=0;y=y+16;} // Move position for the next part.
	}
	
}



// Buffer Phings
void LockBuffer(UIImage* ImageLock)
{
	CGImageRef oldimage = ImageLock.CGImage;
	CGColorSpaceRef colorspace = CGColorSpaceCreateDeviceRGB();
    ctx = CGBitmapContextCreate(NULL,
								CGImageGetWidth(oldimage), CGImageGetHeight(oldimage),
								8, CGImageGetWidth(oldimage) * 4,
								colorspace, kCGImageAlphaPremultipliedLast);
    CGColorSpaceRelease(colorspace);
	BufferHeight=CGImageGetHeight(oldimage);
	
	CGContextSetBlendMode(ctx, kCGBlendModeCopy);
	
	CGRect r = CGRectMake(0,0,CGImageGetWidth(oldimage), CGImageGetHeight(oldimage));
    CGContextDrawImage(ctx, r, oldimage);	
}

void DrawToBuffer(UIImage* ImageDraw,int x,int y)
{
	CGImageRef useimage = ImageDraw.CGImage;
	CGContextSetBlendMode(ctx, kCGBlendModeCopy);
	// add new image
		
    CGRect r = CGRectMake(x,y-BufferHeight,CGImageGetWidth(useimage),CGImageGetHeight(useimage));
    CGContextDrawImage(ctx, r, useimage);	
}

UIImage* UnlockBuffer()
{
    // create resulting image
	CGImageRef thisimage;
    thisimage = CGBitmapContextCreateImage(ctx);
    UIImage* newImage = [[UIImage alloc] initWithCGImage:thisimage];
	
	CGImageRelease(thisimage);
	
    CGContextRelease(ctx);
	
    return newImage;	
}


/*
// Override to allow orientations other than the default portrait orientation.
- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation {
    // Return YES for supported orientations
    return (interfaceOrientation == UIInterfaceOrientationPortrait);
}
*/

- (void)didReceiveMemoryWarning {
	// Releases the view if it doesn't have a superview.
    [super didReceiveMemoryWarning];
	
	// Release any cached data, images, etc that aren't in use.
}

- (void)viewDidUnload {
	// Release any retained subviews of the main view.
	// e.g. self.myOutlet = nil;
}


- (void)dealloc {
    [super dealloc];
	[img_DotsFull dealloc];
	[*img_Dots dealloc];
	[img_Blank dealloc];
}

@end
